/****************************************************************************
 * Copyright (C) 2014-2018 Intel Corporation.   All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 *
 * @file gen_state_llvm.h
 *
 * @brief auto-generated file
 *
 * DO NOT EDIT
 *
 * Generation Command Line:
 *   ../src/gallium/drivers/swr/rasterizer/codegen/gen_llvm_types.py
 *     --input
 *     ../src/gallium/drivers/swr/rasterizer/core/state.h
 *     --output
 *     src/gallium/drivers/swr/rasterizer/codegen/gen_state_llvm.h
 *
 ******************************************************************************/
// clang-format off

#include <llvm/IR/DerivedTypes.h>

#pragma once

namespace SwrJit
{
    using namespace llvm;

    INLINE static StructType* Gen_simdvertex(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "simdvertex");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("simdvertex");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* attrib */ ArrayType::get(ArrayType::get(getVectorType(Type::getFloatTy(ctx), 8), 4), SWR_VTX_NUM_SLOTS),
            };

            pRetType = StructType::create(members, "simdvertex", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("attrib", 202),
            };
            pJitMgr->CreateDebugStructType(pRetType, "simdvertex", pFile, 200, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t simdvertex_attrib = 0;

    INLINE static StructType* Gen_simd16vertex(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "simd16vertex");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("simd16vertex");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* attrib */ ArrayType::get(ArrayType::get(getVectorType(Type::getFloatTy(ctx), 16), 4), SWR_VTX_NUM_SLOTS),
            };

            pRetType = StructType::create(members, "simd16vertex", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("attrib", 207),
            };
            pJitMgr->CreateDebugStructType(pRetType, "simd16vertex", pFile, 205, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t simd16vertex_attrib = 0;

    INLINE static StructType* Gen_SIMDVERTEX_T(JitManager* pJitMgr)
    {
#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SIMDVERTEX_T");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SIMDVERTEX_T");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
            };

            pRetType = StructType::create(members, "SIMDVERTEX_T", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
            };
            pJitMgr->CreateDebugStructType(pRetType, "SIMDVERTEX_T", pFile, 211, dbgMembers);
        }

        return pRetType;
    }


    INLINE static StructType* Gen_SWR_WORKER_DATA(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_WORKER_DATA");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_WORKER_DATA");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* hArContext */ PointerType::get(Type::getInt32Ty(ctx), 0),
            };

            pRetType = StructType::create(members, "SWR_WORKER_DATA", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("hArContext", 218),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_WORKER_DATA", pFile, 216, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_WORKER_DATA_hArContext = 0;

    INLINE static StructType* Gen_SWR_SHADER_STATS(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_SHADER_STATS");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_SHADER_STATS");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* numInstExecuted        */ Type::getInt32Ty(ctx),
                /* numSampleExecuted      */ Type::getInt32Ty(ctx),
                /* numSampleLExecuted     */ Type::getInt32Ty(ctx),
                /* numSampleBExecuted     */ Type::getInt32Ty(ctx),
                /* numSampleCExecuted     */ Type::getInt32Ty(ctx),
                /* numSampleCLZExecuted   */ Type::getInt32Ty(ctx),
                /* numSampleCDExecuted    */ Type::getInt32Ty(ctx),
                /* numGather4Executed     */ Type::getInt32Ty(ctx),
                /* numGather4CExecuted    */ Type::getInt32Ty(ctx),
                /* numGather4CPOExecuted  */ Type::getInt32Ty(ctx),
                /* numGather4CPOCExecuted */ Type::getInt32Ty(ctx),
                /* numLodExecuted         */ Type::getInt32Ty(ctx),
            };

            pRetType = StructType::create(members, "SWR_SHADER_STATS", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("numInstExecuted",        227),
                std::make_pair("numSampleExecuted",      228),
                std::make_pair("numSampleLExecuted",     229),
                std::make_pair("numSampleBExecuted",     230),
                std::make_pair("numSampleCExecuted",     231),
                std::make_pair("numSampleCLZExecuted",   232),
                std::make_pair("numSampleCDExecuted",    233),
                std::make_pair("numGather4Executed",     234),
                std::make_pair("numGather4CExecuted",    235),
                std::make_pair("numGather4CPOExecuted",  236),
                std::make_pair("numGather4CPOCExecuted", 237),
                std::make_pair("numLodExecuted",         238),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_SHADER_STATS", pFile, 225, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_SHADER_STATS_numInstExecuted        = 0;
    static const uint32_t SWR_SHADER_STATS_numSampleExecuted      = 1;
    static const uint32_t SWR_SHADER_STATS_numSampleLExecuted     = 2;
    static const uint32_t SWR_SHADER_STATS_numSampleBExecuted     = 3;
    static const uint32_t SWR_SHADER_STATS_numSampleCExecuted     = 4;
    static const uint32_t SWR_SHADER_STATS_numSampleCLZExecuted   = 5;
    static const uint32_t SWR_SHADER_STATS_numSampleCDExecuted    = 6;
    static const uint32_t SWR_SHADER_STATS_numGather4Executed     = 7;
    static const uint32_t SWR_SHADER_STATS_numGather4CExecuted    = 8;
    static const uint32_t SWR_SHADER_STATS_numGather4CPOExecuted  = 9;
    static const uint32_t SWR_SHADER_STATS_numGather4CPOCExecuted = 10;
    static const uint32_t SWR_SHADER_STATS_numLodExecuted         = 11;

    INLINE static StructType* Gen_SWR_VS_CONTEXT(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_VS_CONTEXT");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_VS_CONTEXT");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* pVin            */ PointerType::get(Gen_simdvertex(pJitMgr), 0),
                /* pVout           */ PointerType::get(Gen_simdvertex(pJitMgr), 0),
                /* InstanceID      */ Type::getInt32Ty(ctx),
                /* VertexID        */ getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth),
                /* mask            */ getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth),
                /* AlternateOffset */ Type::getInt32Ty(ctx),
                /* mask16          */ getVectorType(Type::getInt32Ty(ctx), 16),
                /* VertexID16      */ getVectorType(Type::getInt32Ty(ctx), 16),
                /* stats           */ Gen_SWR_SHADER_STATS(pJitMgr),
            };

            pRetType = StructType::create(members, "SWR_VS_CONTEXT", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("pVin",            248),
                std::make_pair("pVout",           249),
                std::make_pair("InstanceID",      251),
                std::make_pair("VertexID",        252),
                std::make_pair("mask",            253),
                std::make_pair("AlternateOffset", 256),
                std::make_pair("mask16",          258),
                std::make_pair("VertexID16",      259),
                std::make_pair("stats",           261),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_VS_CONTEXT", pFile, 246, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_VS_CONTEXT_pVin            = 0;
    static const uint32_t SWR_VS_CONTEXT_pVout           = 1;
    static const uint32_t SWR_VS_CONTEXT_InstanceID      = 2;
    static const uint32_t SWR_VS_CONTEXT_VertexID        = 3;
    static const uint32_t SWR_VS_CONTEXT_mask            = 4;
    static const uint32_t SWR_VS_CONTEXT_AlternateOffset = 5;
    static const uint32_t SWR_VS_CONTEXT_mask16          = 6;
    static const uint32_t SWR_VS_CONTEXT_VertexID16      = 7;
    static const uint32_t SWR_VS_CONTEXT_stats           = 8;

    INLINE static StructType* Gen_ScalarAttrib(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "ScalarAttrib");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("ScalarAttrib");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* x */ Type::getFloatTy(ctx),
                /* y */ Type::getFloatTy(ctx),
                /* z */ Type::getFloatTy(ctx),
                /* w */ Type::getFloatTy(ctx),
            };

            pRetType = StructType::create(members, "ScalarAttrib", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("x", 271),
                std::make_pair("y", 272),
                std::make_pair("z", 273),
                std::make_pair("w", 274),
            };
            pJitMgr->CreateDebugStructType(pRetType, "ScalarAttrib", pFile, 269, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t ScalarAttrib_x = 0;
    static const uint32_t ScalarAttrib_y = 1;
    static const uint32_t ScalarAttrib_z = 2;
    static const uint32_t ScalarAttrib_w = 3;

    INLINE static StructType* Gen_ScalarCPoint(JitManager* pJitMgr)
    {
#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "ScalarCPoint");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("ScalarCPoint");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* attrib */ ArrayType::get(Gen_ScalarAttrib(pJitMgr), SWR_VTX_NUM_SLOTS),
            };

            pRetType = StructType::create(members, "ScalarCPoint", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("attrib", 279),
            };
            pJitMgr->CreateDebugStructType(pRetType, "ScalarCPoint", pFile, 277, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t ScalarCPoint_attrib = 0;

    INLINE static StructType* Gen_SWR_TESSELLATION_FACTORS(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_TESSELLATION_FACTORS");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_TESSELLATION_FACTORS");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* OuterTessFactors */ ArrayType::get(Type::getFloatTy(ctx), SWR_NUM_OUTER_TESS_FACTORS),
                /* InnerTessFactors */ ArrayType::get(Type::getFloatTy(ctx), SWR_NUM_INNER_TESS_FACTORS),
                /* pad              */ ArrayType::get(Type::getFloatTy(ctx), 2),
            };

            pRetType = StructType::create(members, "SWR_TESSELLATION_FACTORS", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("OuterTessFactors", 288),
                std::make_pair("InnerTessFactors", 289),
                std::make_pair("pad",              290),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_TESSELLATION_FACTORS", pFile, 286, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_TESSELLATION_FACTORS_OuterTessFactors = 0;
    static const uint32_t SWR_TESSELLATION_FACTORS_InnerTessFactors = 1;
    static const uint32_t SWR_TESSELLATION_FACTORS_pad              = 2;

    INLINE static StructType* Gen_ScalarPatch(JitManager* pJitMgr)
    {
#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "ScalarPatch");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("ScalarPatch");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* tessFactors */ Gen_SWR_TESSELLATION_FACTORS(pJitMgr),
                /* cp          */ ArrayType::get(Gen_ScalarCPoint(pJitMgr), MAX_NUM_VERTS_PER_PRIM),
                /* patchData   */ Gen_ScalarCPoint(pJitMgr),
            };

            pRetType = StructType::create(members, "ScalarPatch", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("tessFactors", 298),
                std::make_pair("cp",          299),
                std::make_pair("patchData",   300),
            };
            pJitMgr->CreateDebugStructType(pRetType, "ScalarPatch", pFile, 296, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t ScalarPatch_tessFactors = 0;
    static const uint32_t ScalarPatch_cp          = 1;
    static const uint32_t ScalarPatch_patchData   = 2;

    INLINE static StructType* Gen_SWR_HS_CONTEXT(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_HS_CONTEXT");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_HS_CONTEXT");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* vert        */ ArrayType::get(Gen_simdvertex(pJitMgr), MAX_NUM_VERTS_PER_PRIM),
                /* PrimitiveID */ getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth),
                /* mask        */ getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth),
                /* outputSize  */ Type::getInt32Ty(ctx),
                /* pCPout      */ PointerType::get(Gen_ScalarPatch(pJitMgr), 0),
                /* stats       */ Gen_SWR_SHADER_STATS(pJitMgr),
            };

            pRetType = StructType::create(members, "SWR_HS_CONTEXT", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("vert",        309),
                std::make_pair("PrimitiveID", 310),
                std::make_pair("mask",        311),
                std::make_pair("outputSize",  312),
                std::make_pair("pCPout",      313),
                std::make_pair("stats",       314),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_HS_CONTEXT", pFile, 307, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_HS_CONTEXT_vert        = 0;
    static const uint32_t SWR_HS_CONTEXT_PrimitiveID = 1;
    static const uint32_t SWR_HS_CONTEXT_mask        = 2;
    static const uint32_t SWR_HS_CONTEXT_outputSize  = 3;
    static const uint32_t SWR_HS_CONTEXT_pCPout      = 4;
    static const uint32_t SWR_HS_CONTEXT_stats       = 5;

    INLINE static StructType* Gen_SWR_DS_CONTEXT(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_DS_CONTEXT");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_DS_CONTEXT");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* PrimitiveID           */ Type::getInt32Ty(ctx),
                /* vectorOffset          */ Type::getInt32Ty(ctx),
                /* vectorStride          */ Type::getInt32Ty(ctx),
                /* outVertexAttribOffset */ Type::getInt32Ty(ctx),
                /* pCpIn                 */ PointerType::get(Gen_ScalarPatch(pJitMgr), 0),
                /* pDomainU              */ PointerType::get(getVectorType(Type::getFloatTy(ctx), pJitMgr->mVWidth), 0),
                /* pDomainV              */ PointerType::get(getVectorType(Type::getFloatTy(ctx), pJitMgr->mVWidth), 0),
                /* mask                  */ getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth),
                /* pOutputData           */ PointerType::get(getVectorType(Type::getFloatTy(ctx), pJitMgr->mVWidth), 0),
                /* stats                 */ Gen_SWR_SHADER_STATS(pJitMgr),
            };

            pRetType = StructType::create(members, "SWR_DS_CONTEXT", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("PrimitiveID",           323),
                std::make_pair("vectorOffset",          324),
                std::make_pair("vectorStride",          325),
                std::make_pair("outVertexAttribOffset", 326),
                std::make_pair("pCpIn",                 327),
                std::make_pair("pDomainU",              328),
                std::make_pair("pDomainV",              329),
                std::make_pair("mask",                  330),
                std::make_pair("pOutputData",           331),
                std::make_pair("stats",                 332),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_DS_CONTEXT", pFile, 321, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_DS_CONTEXT_PrimitiveID           = 0;
    static const uint32_t SWR_DS_CONTEXT_vectorOffset          = 1;
    static const uint32_t SWR_DS_CONTEXT_vectorStride          = 2;
    static const uint32_t SWR_DS_CONTEXT_outVertexAttribOffset = 3;
    static const uint32_t SWR_DS_CONTEXT_pCpIn                 = 4;
    static const uint32_t SWR_DS_CONTEXT_pDomainU              = 5;
    static const uint32_t SWR_DS_CONTEXT_pDomainV              = 6;
    static const uint32_t SWR_DS_CONTEXT_mask                  = 7;
    static const uint32_t SWR_DS_CONTEXT_pOutputData           = 8;
    static const uint32_t SWR_DS_CONTEXT_stats                 = 9;

    INLINE static StructType* Gen_SWR_GS_CONTEXT(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_GS_CONTEXT");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_GS_CONTEXT");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* pVerts          */ PointerType::get(ArrayType::get(getVectorType(Type::getFloatTy(ctx), 8), 4), 0),
                /* inputVertStride */ Type::getInt32Ty(ctx),
                /* PrimitiveID     */ getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth),
                /* InstanceID      */ Type::getInt32Ty(ctx),
                /* mask            */ getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth),
                /* pStreams        */ ArrayType::get(PointerType::get(Type::getInt8Ty(ctx), 0), KNOB_SIMD_WIDTH),
                /* stats           */ Gen_SWR_SHADER_STATS(pJitMgr),
            };

            pRetType = StructType::create(members, "SWR_GS_CONTEXT", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("pVerts",          341),
                std::make_pair("inputVertStride", 342),
                std::make_pair("PrimitiveID",     343),
                std::make_pair("InstanceID",      344),
                std::make_pair("mask",            345),
                std::make_pair("pStreams",        346),
                std::make_pair("stats",           347),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_GS_CONTEXT", pFile, 339, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_GS_CONTEXT_pVerts          = 0;
    static const uint32_t SWR_GS_CONTEXT_inputVertStride = 1;
    static const uint32_t SWR_GS_CONTEXT_PrimitiveID     = 2;
    static const uint32_t SWR_GS_CONTEXT_InstanceID      = 3;
    static const uint32_t SWR_GS_CONTEXT_mask            = 4;
    static const uint32_t SWR_GS_CONTEXT_pStreams        = 5;
    static const uint32_t SWR_GS_CONTEXT_stats           = 6;

    INLINE static StructType* Gen_PixelPositions(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "PixelPositions");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("PixelPositions");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* UL       */ getVectorType(Type::getFloatTy(ctx), pJitMgr->mVWidth),
                /* center   */ getVectorType(Type::getFloatTy(ctx), pJitMgr->mVWidth),
                /* sample   */ getVectorType(Type::getFloatTy(ctx), pJitMgr->mVWidth),
                /* centroid */ getVectorType(Type::getFloatTy(ctx), pJitMgr->mVWidth),
            };

            pRetType = StructType::create(members, "PixelPositions", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("UL",       352),
                std::make_pair("center",   353),
                std::make_pair("sample",   354),
                std::make_pair("centroid", 355),
            };
            pJitMgr->CreateDebugStructType(pRetType, "PixelPositions", pFile, 350, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t PixelPositions_UL       = 0;
    static const uint32_t PixelPositions_center   = 1;
    static const uint32_t PixelPositions_sample   = 2;
    static const uint32_t PixelPositions_centroid = 3;

    INLINE static StructType* Gen_SWR_PS_CONTEXT(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_PS_CONTEXT");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_PS_CONTEXT");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* vX                     */ Gen_PixelPositions(pJitMgr),
                /* vY                     */ Gen_PixelPositions(pJitMgr),
                /* vZ                     */ getVectorType(Type::getFloatTy(ctx), pJitMgr->mVWidth),
                /* activeMask             */ getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth),
                /* inputMask              */ getVectorType(Type::getFloatTy(ctx), pJitMgr->mVWidth),
                /* oMask                  */ getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth),
                /* vI                     */ Gen_PixelPositions(pJitMgr),
                /* vJ                     */ Gen_PixelPositions(pJitMgr),
                /* vOneOverW              */ Gen_PixelPositions(pJitMgr),
                /* pAttribs               */ PointerType::get(Type::getFloatTy(ctx), 0),
                /* pPerspAttribs          */ PointerType::get(Type::getFloatTy(ctx), 0),
                /* pRecipW                */ PointerType::get(Type::getFloatTy(ctx), 0),
                /* I                      */ PointerType::get(Type::getFloatTy(ctx), 0),
                /* J                      */ PointerType::get(Type::getFloatTy(ctx), 0),
                /* recipDet               */ Type::getFloatTy(ctx),
                /* pSamplePosX            */ PointerType::get(Type::getFloatTy(ctx), 0),
                /* pSamplePosY            */ PointerType::get(Type::getFloatTy(ctx), 0),
                /* shaded                 */ ArrayType::get(ArrayType::get(getVectorType(Type::getFloatTy(ctx), 8), 4), SWR_NUM_RENDERTARGETS),
                /* frontFace              */ Type::getInt32Ty(ctx),
                /* sampleIndex            */ Type::getInt32Ty(ctx),
                /* renderTargetArrayIndex */ Type::getInt32Ty(ctx),
                /* viewportIndex          */ Type::getInt32Ty(ctx),
                /* rasterizerSampleCount  */ Type::getInt32Ty(ctx),
                /* pColorBuffer           */ ArrayType::get(PointerType::get(Type::getInt8Ty(ctx), 0), SWR_NUM_RENDERTARGETS),
                /* stats                  */ Gen_SWR_SHADER_STATS(pJitMgr),
                /* pBucketManager         */ PointerType::get(Type::getInt32Ty(ctx), 0),
            };

            pRetType = StructType::create(members, "SWR_PS_CONTEXT", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("vX",                     366),
                std::make_pair("vY",                     367),
                std::make_pair("vZ",                     368),
                std::make_pair("activeMask",             369),
                std::make_pair("inputMask",              370),
                std::make_pair("oMask",                  371),
                std::make_pair("vI",                     373),
                std::make_pair("vJ",                     374),
                std::make_pair("vOneOverW",              375),
                std::make_pair("pAttribs",               377),
                std::make_pair("pPerspAttribs",          378),
                std::make_pair("pRecipW",                379),
                std::make_pair("I",                      380),
                std::make_pair("J",                      381),
                std::make_pair("recipDet",               382),
                std::make_pair("pSamplePosX",            383),
                std::make_pair("pSamplePosY",            384),
                std::make_pair("shaded",                 385),
                std::make_pair("frontFace",              387),
                std::make_pair("sampleIndex",            388),
                std::make_pair("renderTargetArrayIndex", 389),
                std::make_pair("viewportIndex",          390),
                std::make_pair("rasterizerSampleCount",  391),
                std::make_pair("pColorBuffer",           393),
                std::make_pair("stats",                  395),
                std::make_pair("pBucketManager",         397),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_PS_CONTEXT", pFile, 364, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_PS_CONTEXT_vX                     = 0;
    static const uint32_t SWR_PS_CONTEXT_vY                     = 1;
    static const uint32_t SWR_PS_CONTEXT_vZ                     = 2;
    static const uint32_t SWR_PS_CONTEXT_activeMask             = 3;
    static const uint32_t SWR_PS_CONTEXT_inputMask              = 4;
    static const uint32_t SWR_PS_CONTEXT_oMask                  = 5;
    static const uint32_t SWR_PS_CONTEXT_vI                     = 6;
    static const uint32_t SWR_PS_CONTEXT_vJ                     = 7;
    static const uint32_t SWR_PS_CONTEXT_vOneOverW              = 8;
    static const uint32_t SWR_PS_CONTEXT_pAttribs               = 9;
    static const uint32_t SWR_PS_CONTEXT_pPerspAttribs          = 10;
    static const uint32_t SWR_PS_CONTEXT_pRecipW                = 11;
    static const uint32_t SWR_PS_CONTEXT_I                      = 12;
    static const uint32_t SWR_PS_CONTEXT_J                      = 13;
    static const uint32_t SWR_PS_CONTEXT_recipDet               = 14;
    static const uint32_t SWR_PS_CONTEXT_pSamplePosX            = 15;
    static const uint32_t SWR_PS_CONTEXT_pSamplePosY            = 16;
    static const uint32_t SWR_PS_CONTEXT_shaded                 = 17;
    static const uint32_t SWR_PS_CONTEXT_frontFace              = 18;
    static const uint32_t SWR_PS_CONTEXT_sampleIndex            = 19;
    static const uint32_t SWR_PS_CONTEXT_renderTargetArrayIndex = 20;
    static const uint32_t SWR_PS_CONTEXT_viewportIndex          = 21;
    static const uint32_t SWR_PS_CONTEXT_rasterizerSampleCount  = 22;
    static const uint32_t SWR_PS_CONTEXT_pColorBuffer           = 23;
    static const uint32_t SWR_PS_CONTEXT_stats                  = 24;
    static const uint32_t SWR_PS_CONTEXT_pBucketManager         = 25;

    INLINE static StructType* Gen_SWR_CS_CONTEXT(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_CS_CONTEXT");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_CS_CONTEXT");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* tileCounter         */ Type::getInt32Ty(ctx),
                /* dispatchDims        */ ArrayType::get(Type::getInt32Ty(ctx), 3),
                /* pTGSM               */ PointerType::get(Type::getInt8Ty(ctx), 0),
                /* pSpillFillBuffer    */ PointerType::get(Type::getInt8Ty(ctx), 0),
                /* pScratchSpace       */ PointerType::get(Type::getInt8Ty(ctx), 0),
                /* scratchSpacePerWarp */ Type::getInt32Ty(ctx),
                /* stats               */ Gen_SWR_SHADER_STATS(pJitMgr),
            };

            pRetType = StructType::create(members, "SWR_CS_CONTEXT", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("tileCounter",         426),
                std::make_pair("dispatchDims",        429),
                std::make_pair("pTGSM",               431),
                std::make_pair("pSpillFillBuffer",    432),
                std::make_pair("pScratchSpace",       433),
                std::make_pair("scratchSpacePerWarp", 435),
                std::make_pair("stats",               437),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_CS_CONTEXT", pFile, 404, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_CS_CONTEXT_tileCounter         = 0;
    static const uint32_t SWR_CS_CONTEXT_dispatchDims        = 1;
    static const uint32_t SWR_CS_CONTEXT_pTGSM               = 2;
    static const uint32_t SWR_CS_CONTEXT_pSpillFillBuffer    = 3;
    static const uint32_t SWR_CS_CONTEXT_pScratchSpace       = 4;
    static const uint32_t SWR_CS_CONTEXT_scratchSpacePerWarp = 5;
    static const uint32_t SWR_CS_CONTEXT_stats               = 6;

    INLINE static StructType* Gen_SWR_VERTEX_BUFFER_STATE(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_VERTEX_BUFFER_STATE");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_VERTEX_BUFFER_STATE");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* xpData              */ Type::getInt64Ty(ctx),
                /* index               */ Type::getInt32Ty(ctx),
                /* pitch               */ Type::getInt32Ty(ctx),
                /* size                */ Type::getInt32Ty(ctx),
                /* minVertex           */ Type::getInt32Ty(ctx),
                /* maxVertex           */ Type::getInt32Ty(ctx),
                /* partialInboundsSize */ Type::getInt32Ty(ctx),
            };

            pRetType = StructType::create(members, "SWR_VERTEX_BUFFER_STATE", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("xpData",              558),
                std::make_pair("index",               559),
                std::make_pair("pitch",               560),
                std::make_pair("size",                561),
                std::make_pair("minVertex",           562),
                std::make_pair("maxVertex",           563),
                std::make_pair("partialInboundsSize", 564),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_VERTEX_BUFFER_STATE", pFile, 556, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_VERTEX_BUFFER_STATE_xpData              = 0;
    static const uint32_t SWR_VERTEX_BUFFER_STATE_index               = 1;
    static const uint32_t SWR_VERTEX_BUFFER_STATE_pitch               = 2;
    static const uint32_t SWR_VERTEX_BUFFER_STATE_size                = 3;
    static const uint32_t SWR_VERTEX_BUFFER_STATE_minVertex           = 4;
    static const uint32_t SWR_VERTEX_BUFFER_STATE_maxVertex           = 5;
    static const uint32_t SWR_VERTEX_BUFFER_STATE_partialInboundsSize = 6;

    INLINE static StructType* Gen_SWR_INDEX_BUFFER_STATE(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_INDEX_BUFFER_STATE");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_INDEX_BUFFER_STATE");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* xpIndices */ Type::getInt64Ty(ctx),
                /* format    */ Type::getInt32Ty(ctx),
                /* size      */ Type::getInt32Ty(ctx),
            };

            pRetType = StructType::create(members, "SWR_INDEX_BUFFER_STATE", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("xpIndices", 570),
                std::make_pair("format",    572),
                std::make_pair("size",      573),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_INDEX_BUFFER_STATE", pFile, 568, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_INDEX_BUFFER_STATE_xpIndices = 0;
    static const uint32_t SWR_INDEX_BUFFER_STATE_format    = 1;
    static const uint32_t SWR_INDEX_BUFFER_STATE_size      = 2;

    INLINE static StructType* Gen_SWR_FETCH_CONTEXT(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_FETCH_CONTEXT");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_FETCH_CONTEXT");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* pStreams      */ PointerType::get(Gen_SWR_VERTEX_BUFFER_STATE(pJitMgr), 0),
                /* xpIndices     */ Type::getInt64Ty(ctx),
                /* xpLastIndex   */ Type::getInt64Ty(ctx),
                /* CurInstance   */ Type::getInt32Ty(ctx),
                /* BaseVertex    */ Type::getInt32Ty(ctx),
                /* StartVertex   */ Type::getInt32Ty(ctx),
                /* StartInstance */ Type::getInt32Ty(ctx),
                /* VertexID      */ getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth),
                /* CutMask       */ getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth),
                /* VertexID2     */ getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth),
                /* CutMask2      */ getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth),
            };

            pRetType = StructType::create(members, "SWR_FETCH_CONTEXT", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("pStreams",      584),
                std::make_pair("xpIndices",     585),
                std::make_pair("xpLastIndex",   586),
                std::make_pair("CurInstance",   587),
                std::make_pair("BaseVertex",    588),
                std::make_pair("StartVertex",   589),
                std::make_pair("StartInstance", 590),
                std::make_pair("VertexID",      591),
                std::make_pair("CutMask",       592),
                std::make_pair("VertexID2",     597),
                std::make_pair("CutMask2",      598),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_FETCH_CONTEXT", pFile, 582, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_FETCH_CONTEXT_pStreams      = 0;
    static const uint32_t SWR_FETCH_CONTEXT_xpIndices     = 1;
    static const uint32_t SWR_FETCH_CONTEXT_xpLastIndex   = 2;
    static const uint32_t SWR_FETCH_CONTEXT_CurInstance   = 3;
    static const uint32_t SWR_FETCH_CONTEXT_BaseVertex    = 4;
    static const uint32_t SWR_FETCH_CONTEXT_StartVertex   = 5;
    static const uint32_t SWR_FETCH_CONTEXT_StartInstance = 6;
    static const uint32_t SWR_FETCH_CONTEXT_VertexID      = 7;
    static const uint32_t SWR_FETCH_CONTEXT_CutMask       = 8;
    static const uint32_t SWR_FETCH_CONTEXT_VertexID2     = 9;
    static const uint32_t SWR_FETCH_CONTEXT_CutMask2      = 10;

    INLINE static StructType* Gen_SWR_STREAMOUT_BUFFER(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_STREAMOUT_BUFFER");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_STREAMOUT_BUFFER");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* pBuffer       */ Type::getInt64Ty(ctx),
                /* pWriteOffset  */ Type::getInt64Ty(ctx),
                /* enable        */ Type::getInt8Ty(ctx),
                /* soWriteEnable */ Type::getInt8Ty(ctx),
                /* bufferSize    */ Type::getInt32Ty(ctx),
                /* pitch         */ Type::getInt32Ty(ctx),
                /* streamOffset  */ Type::getInt32Ty(ctx),
            };

            pRetType = StructType::create(members, "SWR_STREAMOUT_BUFFER", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("pBuffer",       652),
                std::make_pair("pWriteOffset",  655),
                std::make_pair("enable",        657),
                std::make_pair("soWriteEnable", 658),
                std::make_pair("bufferSize",    661),
                std::make_pair("pitch",         664),
                std::make_pair("streamOffset",  667),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_STREAMOUT_BUFFER", pFile, 649, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_STREAMOUT_BUFFER_pBuffer       = 0;
    static const uint32_t SWR_STREAMOUT_BUFFER_pWriteOffset  = 1;
    static const uint32_t SWR_STREAMOUT_BUFFER_enable        = 2;
    static const uint32_t SWR_STREAMOUT_BUFFER_soWriteEnable = 3;
    static const uint32_t SWR_STREAMOUT_BUFFER_bufferSize    = 4;
    static const uint32_t SWR_STREAMOUT_BUFFER_pitch         = 5;
    static const uint32_t SWR_STREAMOUT_BUFFER_streamOffset  = 6;

    INLINE static StructType* Gen_SWR_STREAMOUT_STATE(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_STREAMOUT_STATE");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_STREAMOUT_STATE");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* soEnable           */ Type::getInt8Ty(ctx),
                /* streamEnable       */ ArrayType::get(Type::getInt8Ty(ctx), MAX_SO_STREAMS),
                /* rasterizerDisable  */ Type::getInt8Ty(ctx),
                /* streamToRasterizer */ Type::getInt32Ty(ctx),
                /* streamMasks        */ ArrayType::get(Type::getInt64Ty(ctx), MAX_SO_STREAMS),
                /* streamNumEntries   */ ArrayType::get(Type::getInt32Ty(ctx), MAX_SO_STREAMS),
                /* vertexAttribOffset */ ArrayType::get(Type::getInt32Ty(ctx), MAX_SO_STREAMS),
            };

            pRetType = StructType::create(members, "SWR_STREAMOUT_STATE", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("soEnable",           676),
                std::make_pair("streamEnable",       679),
                std::make_pair("rasterizerDisable",  682),
                std::make_pair("streamToRasterizer", 685),
                std::make_pair("streamMasks",        690),
                std::make_pair("streamNumEntries",   694),
                std::make_pair("vertexAttribOffset", 697),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_STREAMOUT_STATE", pFile, 673, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_STREAMOUT_STATE_soEnable           = 0;
    static const uint32_t SWR_STREAMOUT_STATE_streamEnable       = 1;
    static const uint32_t SWR_STREAMOUT_STATE_rasterizerDisable  = 2;
    static const uint32_t SWR_STREAMOUT_STATE_streamToRasterizer = 3;
    static const uint32_t SWR_STREAMOUT_STATE_streamMasks        = 4;
    static const uint32_t SWR_STREAMOUT_STATE_streamNumEntries   = 5;
    static const uint32_t SWR_STREAMOUT_STATE_vertexAttribOffset = 6;

    INLINE static StructType* Gen_SWR_STREAMOUT_CONTEXT(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_STREAMOUT_CONTEXT");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_STREAMOUT_CONTEXT");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* pPrimData            */ PointerType::get(Type::getInt32Ty(ctx), 0),
                /* pBuffer              */ ArrayType::get(PointerType::get(Gen_SWR_STREAMOUT_BUFFER(pJitMgr), 0), MAX_SO_STREAMS),
                /* numPrimsWritten      */ Type::getInt32Ty(ctx),
                /* numPrimStorageNeeded */ Type::getInt32Ty(ctx),
            };

            pRetType = StructType::create(members, "SWR_STREAMOUT_CONTEXT", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("pPrimData",            705),
                std::make_pair("pBuffer",              706),
                std::make_pair("numPrimsWritten",      709),
                std::make_pair("numPrimStorageNeeded", 712),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_STREAMOUT_CONTEXT", pFile, 703, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_STREAMOUT_CONTEXT_pPrimData            = 0;
    static const uint32_t SWR_STREAMOUT_CONTEXT_pBuffer              = 1;
    static const uint32_t SWR_STREAMOUT_CONTEXT_numPrimsWritten      = 2;
    static const uint32_t SWR_STREAMOUT_CONTEXT_numPrimStorageNeeded = 3;

    INLINE static StructType* Gen_SWR_GS_STATE(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_GS_STATE");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_GS_STATE");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* gsEnable           */ Type::getInt8Ty(ctx),
                /* isSingleStream     */ Type::getInt8Ty(ctx),
                /* numInputAttribs    */ Type::getInt32Ty(ctx),
                /* inputVertStride    */ Type::getInt32Ty(ctx),
                /* outputTopology     */ Type::getInt32Ty(ctx),
                /* maxNumVerts        */ Type::getInt32Ty(ctx),
                /* instanceCount      */ Type::getInt32Ty(ctx),
                /* singleStreamID     */ Type::getInt32Ty(ctx),
                /* allocationSize     */ Type::getInt32Ty(ctx),
                /* vertexAttribOffset */ Type::getInt32Ty(ctx),
                /* controlDataSize    */ Type::getInt32Ty(ctx),
                /* controlDataOffset  */ Type::getInt32Ty(ctx),
                /* outputVertexSize   */ Type::getInt32Ty(ctx),
                /* outputVertexOffset */ Type::getInt32Ty(ctx),
                /* staticVertexCount  */ Type::getInt32Ty(ctx),
            };

            pRetType = StructType::create(members, "SWR_GS_STATE", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("gsEnable",           720),
                std::make_pair("isSingleStream",     725),
                std::make_pair("numInputAttribs",    729),
                std::make_pair("inputVertStride",    732),
                std::make_pair("outputTopology",     735),
                std::make_pair("maxNumVerts",        738),
                std::make_pair("instanceCount",      741),
                std::make_pair("singleStreamID",     745),
                std::make_pair("allocationSize",     748),
                std::make_pair("vertexAttribOffset", 753),
                std::make_pair("controlDataSize",    758),
                std::make_pair("controlDataOffset",  761),
                std::make_pair("outputVertexSize",   764),
                std::make_pair("outputVertexOffset", 767),
                std::make_pair("staticVertexCount",  772),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_GS_STATE", pFile, 718, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_GS_STATE_gsEnable           = 0;
    static const uint32_t SWR_GS_STATE_isSingleStream     = 1;
    static const uint32_t SWR_GS_STATE_numInputAttribs    = 2;
    static const uint32_t SWR_GS_STATE_inputVertStride    = 3;
    static const uint32_t SWR_GS_STATE_outputTopology     = 4;
    static const uint32_t SWR_GS_STATE_maxNumVerts        = 5;
    static const uint32_t SWR_GS_STATE_instanceCount      = 6;
    static const uint32_t SWR_GS_STATE_singleStreamID     = 7;
    static const uint32_t SWR_GS_STATE_allocationSize     = 8;
    static const uint32_t SWR_GS_STATE_vertexAttribOffset = 9;
    static const uint32_t SWR_GS_STATE_controlDataSize    = 10;
    static const uint32_t SWR_GS_STATE_controlDataOffset  = 11;
    static const uint32_t SWR_GS_STATE_outputVertexSize   = 12;
    static const uint32_t SWR_GS_STATE_outputVertexOffset = 13;
    static const uint32_t SWR_GS_STATE_staticVertexCount  = 14;

    INLINE static StructType* Gen_SWR_TS_STATE(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_TS_STATE");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_TS_STATE");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* tsEnable              */ Type::getInt8Ty(ctx),
                /* tsOutputTopology      */ Type::getInt32Ty(ctx),
                /* partitioning          */ Type::getInt32Ty(ctx),
                /* domain                */ Type::getInt32Ty(ctx),
                /* postDSTopology        */ Type::getInt32Ty(ctx),
                /* numHsInputAttribs     */ Type::getInt32Ty(ctx),
                /* numHsOutputAttribs    */ Type::getInt32Ty(ctx),
                /* hsAllocationSize      */ Type::getInt32Ty(ctx),
                /* numDsOutputAttribs    */ Type::getInt32Ty(ctx),
                /* dsAllocationSize      */ Type::getInt32Ty(ctx),
                /* dsOutVtxAttribOffset  */ Type::getInt32Ty(ctx),
                /* srcVertexAttribOffset */ Type::getInt32Ty(ctx),
                /* vertexAttribOffset    */ Type::getInt32Ty(ctx),
            };

            pRetType = StructType::create(members, "SWR_TS_STATE", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("tsEnable",              817),
                std::make_pair("tsOutputTopology",      819),
                std::make_pair("partitioning",          820),
                std::make_pair("domain",                821),
                std::make_pair("postDSTopology",        823),
                std::make_pair("numHsInputAttribs",     825),
                std::make_pair("numHsOutputAttribs",    826),
                std::make_pair("hsAllocationSize",      827),
                std::make_pair("numDsOutputAttribs",    829),
                std::make_pair("dsAllocationSize",      830),
                std::make_pair("dsOutVtxAttribOffset",  831),
                std::make_pair("srcVertexAttribOffset", 834),
                std::make_pair("vertexAttribOffset",    837),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_TS_STATE", pFile, 815, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_TS_STATE_tsEnable              = 0;
    static const uint32_t SWR_TS_STATE_tsOutputTopology      = 1;
    static const uint32_t SWR_TS_STATE_partitioning          = 2;
    static const uint32_t SWR_TS_STATE_domain                = 3;
    static const uint32_t SWR_TS_STATE_postDSTopology        = 4;
    static const uint32_t SWR_TS_STATE_numHsInputAttribs     = 5;
    static const uint32_t SWR_TS_STATE_numHsOutputAttribs    = 6;
    static const uint32_t SWR_TS_STATE_hsAllocationSize      = 7;
    static const uint32_t SWR_TS_STATE_numDsOutputAttribs    = 8;
    static const uint32_t SWR_TS_STATE_dsAllocationSize      = 9;
    static const uint32_t SWR_TS_STATE_dsOutVtxAttribOffset  = 10;
    static const uint32_t SWR_TS_STATE_srcVertexAttribOffset = 11;
    static const uint32_t SWR_TS_STATE_vertexAttribOffset    = 12;

    INLINE static StructType* Gen_SWR_RENDER_TARGET_BLEND_STATE(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_RENDER_TARGET_BLEND_STATE");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_RENDER_TARGET_BLEND_STATE");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* writeDisableRed   */ Type::getInt8Ty(ctx),
                /* writeDisableGreen */ Type::getInt8Ty(ctx),
                /* writeDisableBlue  */ Type::getInt8Ty(ctx),
                /* writeDisableAlpha */ Type::getInt8Ty(ctx),
            };

            pRetType = StructType::create(members, "SWR_RENDER_TARGET_BLEND_STATE", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("writeDisableRed",   843),
                std::make_pair("writeDisableGreen", 844),
                std::make_pair("writeDisableBlue",  845),
                std::make_pair("writeDisableAlpha", 846),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_RENDER_TARGET_BLEND_STATE", pFile, 841, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_RENDER_TARGET_BLEND_STATE_writeDisableRed   = 0;
    static const uint32_t SWR_RENDER_TARGET_BLEND_STATE_writeDisableGreen = 1;
    static const uint32_t SWR_RENDER_TARGET_BLEND_STATE_writeDisableBlue  = 2;
    static const uint32_t SWR_RENDER_TARGET_BLEND_STATE_writeDisableAlpha = 3;

    INLINE static StructType* Gen_SWR_BLEND_STATE(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_BLEND_STATE");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_BLEND_STATE");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* constantColor      */ ArrayType::get(Type::getFloatTy(ctx), 4),
                /* alphaTestReference */ Type::getInt32Ty(ctx),
                /* sampleMask         */ Type::getInt32Ty(ctx),
                /* sampleCount        */ Type::getInt32Ty(ctx),
                /* renderTarget       */ ArrayType::get(Gen_SWR_RENDER_TARGET_BLEND_STATE(pJitMgr), SWR_NUM_RENDERTARGETS),
            };

            pRetType = StructType::create(members, "SWR_BLEND_STATE", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("constantColor",      869),
                std::make_pair("alphaTestReference", 872),
                std::make_pair("sampleMask",         873),
                std::make_pair("sampleCount",        876),
                std::make_pair("renderTarget",       878),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_BLEND_STATE", pFile, 866, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_BLEND_STATE_constantColor      = 0;
    static const uint32_t SWR_BLEND_STATE_alphaTestReference = 1;
    static const uint32_t SWR_BLEND_STATE_sampleMask         = 2;
    static const uint32_t SWR_BLEND_STATE_sampleCount        = 3;
    static const uint32_t SWR_BLEND_STATE_renderTarget       = 4;

    INLINE static StructType* Gen_SWR_BLEND_CONTEXT(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_BLEND_CONTEXT");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_BLEND_CONTEXT");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* pBlendState    */ PointerType::get(Gen_SWR_BLEND_STATE(pJitMgr), 0),
                /* src            */ PointerType::get(ArrayType::get(getVectorType(Type::getFloatTy(ctx), 8), 4), 0),
                /* src1           */ PointerType::get(ArrayType::get(getVectorType(Type::getFloatTy(ctx), 8), 4), 0),
                /* src0alpha      */ PointerType::get(ArrayType::get(getVectorType(Type::getFloatTy(ctx), 8), 4), 0),
                /* sampleNum      */ Type::getInt32Ty(ctx),
                /* pDst           */ PointerType::get(ArrayType::get(getVectorType(Type::getFloatTy(ctx), 8), 4), 0),
                /* result         */ PointerType::get(ArrayType::get(getVectorType(Type::getFloatTy(ctx), 8), 4), 0),
                /* oMask          */ PointerType::get(getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth), 0),
                /* pMask          */ PointerType::get(getVectorType(Type::getInt32Ty(ctx), pJitMgr->mVWidth), 0),
                /* isAlphaTested  */ Type::getInt32Ty(ctx),
                /* isAlphaBlended */ Type::getInt32Ty(ctx),
            };

            pRetType = StructType::create(members, "SWR_BLEND_CONTEXT", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("pBlendState",    884),
                std::make_pair("src",            885),
                std::make_pair("src1",           886),
                std::make_pair("src0alpha",      887),
                std::make_pair("sampleNum",      888),
                std::make_pair("pDst",           889),
                std::make_pair("result",         890),
                std::make_pair("oMask",          891),
                std::make_pair("pMask",          892),
                std::make_pair("isAlphaTested",  893),
                std::make_pair("isAlphaBlended", 894),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_BLEND_CONTEXT", pFile, 882, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_BLEND_CONTEXT_pBlendState    = 0;
    static const uint32_t SWR_BLEND_CONTEXT_src            = 1;
    static const uint32_t SWR_BLEND_CONTEXT_src1           = 2;
    static const uint32_t SWR_BLEND_CONTEXT_src0alpha      = 3;
    static const uint32_t SWR_BLEND_CONTEXT_sampleNum      = 4;
    static const uint32_t SWR_BLEND_CONTEXT_pDst           = 5;
    static const uint32_t SWR_BLEND_CONTEXT_result         = 6;
    static const uint32_t SWR_BLEND_CONTEXT_oMask          = 7;
    static const uint32_t SWR_BLEND_CONTEXT_pMask          = 8;
    static const uint32_t SWR_BLEND_CONTEXT_isAlphaTested  = 9;
    static const uint32_t SWR_BLEND_CONTEXT_isAlphaBlended = 10;

    INLINE static StructType* Gen_SWR_FRONTEND_STATE(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_FRONTEND_STATE");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_FRONTEND_STATE");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* vpTransformDisable */ Type::getInt8Ty(ctx),
                /* bEnableCutIndex    */ Type::getInt8Ty(ctx),
                /* triFan             */ Type::getInt32Ty(ctx),
                /* lineStripList      */ Type::getInt32Ty(ctx),
                /* triStripList       */ Type::getInt32Ty(ctx),
            };

            pRetType = StructType::create(members, "SWR_FRONTEND_STATE", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("vpTransformDisable", 924),
                std::make_pair("bEnableCutIndex",    925),
                std::make_pair("triFan",             930),
                std::make_pair("lineStripList",      931),
                std::make_pair("triStripList",       932),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_FRONTEND_STATE", pFile, 920, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_FRONTEND_STATE_vpTransformDisable = 0;
    static const uint32_t SWR_FRONTEND_STATE_bEnableCutIndex    = 1;
    static const uint32_t SWR_FRONTEND_STATE_triFan             = 2;
    static const uint32_t SWR_FRONTEND_STATE_lineStripList      = 3;
    static const uint32_t SWR_FRONTEND_STATE_triStripList       = 4;

    INLINE static StructType* Gen_SWR_VIEWPORT_MATRIX(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_VIEWPORT_MATRIX");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_VIEWPORT_MATRIX");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* m00 */ Type::getFloatTy(ctx),
                /* m11 */ Type::getFloatTy(ctx),
                /* m22 */ Type::getFloatTy(ctx),
                /* m30 */ Type::getFloatTy(ctx),
                /* m31 */ Type::getFloatTy(ctx),
                /* m32 */ Type::getFloatTy(ctx),
            };

            pRetType = StructType::create(members, "SWR_VIEWPORT_MATRIX", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("m00", 948),
                std::make_pair("m11", 949),
                std::make_pair("m22", 950),
                std::make_pair("m30", 951),
                std::make_pair("m31", 952),
                std::make_pair("m32", 953),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_VIEWPORT_MATRIX", pFile, 946, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_VIEWPORT_MATRIX_m00 = 0;
    static const uint32_t SWR_VIEWPORT_MATRIX_m11 = 1;
    static const uint32_t SWR_VIEWPORT_MATRIX_m22 = 2;
    static const uint32_t SWR_VIEWPORT_MATRIX_m30 = 3;
    static const uint32_t SWR_VIEWPORT_MATRIX_m31 = 4;
    static const uint32_t SWR_VIEWPORT_MATRIX_m32 = 5;

    INLINE static StructType* Gen_SWR_VIEWPORT_MATRICES(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_VIEWPORT_MATRICES");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_VIEWPORT_MATRICES");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* m00 */ ArrayType::get(Type::getFloatTy(ctx), KNOB_NUM_VIEWPORTS_SCISSORS),
                /* m11 */ ArrayType::get(Type::getFloatTy(ctx), KNOB_NUM_VIEWPORTS_SCISSORS),
                /* m22 */ ArrayType::get(Type::getFloatTy(ctx), KNOB_NUM_VIEWPORTS_SCISSORS),
                /* m30 */ ArrayType::get(Type::getFloatTy(ctx), KNOB_NUM_VIEWPORTS_SCISSORS),
                /* m31 */ ArrayType::get(Type::getFloatTy(ctx), KNOB_NUM_VIEWPORTS_SCISSORS),
                /* m32 */ ArrayType::get(Type::getFloatTy(ctx), KNOB_NUM_VIEWPORTS_SCISSORS),
            };

            pRetType = StructType::create(members, "SWR_VIEWPORT_MATRICES", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("m00", 961),
                std::make_pair("m11", 962),
                std::make_pair("m22", 963),
                std::make_pair("m30", 964),
                std::make_pair("m31", 965),
                std::make_pair("m32", 966),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_VIEWPORT_MATRICES", pFile, 959, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_VIEWPORT_MATRICES_m00 = 0;
    static const uint32_t SWR_VIEWPORT_MATRICES_m11 = 1;
    static const uint32_t SWR_VIEWPORT_MATRICES_m22 = 2;
    static const uint32_t SWR_VIEWPORT_MATRICES_m30 = 3;
    static const uint32_t SWR_VIEWPORT_MATRICES_m31 = 4;
    static const uint32_t SWR_VIEWPORT_MATRICES_m32 = 5;

    INLINE static StructType* Gen_SWR_VIEWPORT(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_VIEWPORT");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_VIEWPORT");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* x      */ Type::getFloatTy(ctx),
                /* y      */ Type::getFloatTy(ctx),
                /* width  */ Type::getFloatTy(ctx),
                /* height */ Type::getFloatTy(ctx),
                /* minZ   */ Type::getFloatTy(ctx),
                /* maxZ   */ Type::getFloatTy(ctx),
            };

            pRetType = StructType::create(members, "SWR_VIEWPORT", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("x",      974),
                std::make_pair("y",      975),
                std::make_pair("width",  976),
                std::make_pair("height", 977),
                std::make_pair("minZ",   978),
                std::make_pair("maxZ",   979),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_VIEWPORT", pFile, 972, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_VIEWPORT_x      = 0;
    static const uint32_t SWR_VIEWPORT_y      = 1;
    static const uint32_t SWR_VIEWPORT_width  = 2;
    static const uint32_t SWR_VIEWPORT_height = 3;
    static const uint32_t SWR_VIEWPORT_minZ   = 4;
    static const uint32_t SWR_VIEWPORT_maxZ   = 5;

    INLINE static StructType* Gen_SWR_MULTISAMPLE_POS(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_MULTISAMPLE_POS");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_MULTISAMPLE_POS");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* _xi                */ ArrayType::get(Type::getInt32Ty(ctx), SWR_MAX_NUM_MULTISAMPLES),
                /* _yi                */ ArrayType::get(Type::getInt32Ty(ctx), SWR_MAX_NUM_MULTISAMPLES),
                /* _x                 */ ArrayType::get(Type::getFloatTy(ctx), SWR_MAX_NUM_MULTISAMPLES),
                /* _y                 */ ArrayType::get(Type::getFloatTy(ctx), SWR_MAX_NUM_MULTISAMPLES),
                /* _vXi               */ ArrayType::get(getVectorType(Type::getInt32Ty(ctx), 4), SWR_MAX_NUM_MULTISAMPLES),
                /* _vYi               */ ArrayType::get(getVectorType(Type::getInt32Ty(ctx), 4), SWR_MAX_NUM_MULTISAMPLES),
                /* _vX                */ ArrayType::get(getVectorType(Type::getFloatTy(ctx), pJitMgr->mVWidth), SWR_MAX_NUM_MULTISAMPLES),
                /* _vY                */ ArrayType::get(getVectorType(Type::getFloatTy(ctx), pJitMgr->mVWidth), SWR_MAX_NUM_MULTISAMPLES),
                /* tileSampleOffsetsX */ getVectorType(Type::getInt32Ty(ctx), 4),
                /* tileSampleOffsetsY */ getVectorType(Type::getInt32Ty(ctx), 4),
            };

            pRetType = StructType::create(members, "SWR_MULTISAMPLE_POS", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("_xi",                1043),
                std::make_pair("_yi",                1044),
                std::make_pair("_x",                 1045),
                std::make_pair("_y",                 1046),
                std::make_pair("_vXi",               1049),
                std::make_pair("_vYi",               1050),
                std::make_pair("_vX",                1051),
                std::make_pair("_vY",                1052),
                std::make_pair("tileSampleOffsetsX", 1053),
                std::make_pair("tileSampleOffsetsY", 1054),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_MULTISAMPLE_POS", pFile, 1014, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_MULTISAMPLE_POS__xi                = 0;
    static const uint32_t SWR_MULTISAMPLE_POS__yi                = 1;
    static const uint32_t SWR_MULTISAMPLE_POS__x                 = 2;
    static const uint32_t SWR_MULTISAMPLE_POS__y                 = 3;
    static const uint32_t SWR_MULTISAMPLE_POS__vXi               = 4;
    static const uint32_t SWR_MULTISAMPLE_POS__vYi               = 5;
    static const uint32_t SWR_MULTISAMPLE_POS__vX                = 6;
    static const uint32_t SWR_MULTISAMPLE_POS__vY                = 7;
    static const uint32_t SWR_MULTISAMPLE_POS_tileSampleOffsetsX = 8;
    static const uint32_t SWR_MULTISAMPLE_POS_tileSampleOffsetsY = 9;

    INLINE static StructType* Gen_SWR_RASTSTATE(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_RASTSTATE");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_RASTSTATE");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* cullMode             */ Type::getInt32Ty(ctx),
                /* fillMode             */ Type::getInt32Ty(ctx),
                /* frontWinding         */ Type::getInt32Ty(ctx),
                /* scissorEnable        */ Type::getInt32Ty(ctx),
                /* depthClipEnable      */ Type::getInt32Ty(ctx),
                /* clipEnable           */ Type::getInt32Ty(ctx),
                /* clipHalfZ            */ Type::getInt32Ty(ctx),
                /* pointParam           */ Type::getInt32Ty(ctx),
                /* pointSpriteEnable    */ Type::getInt32Ty(ctx),
                /* pointSpriteTopOrigin */ Type::getInt32Ty(ctx),
                /* forcedSampleCount    */ Type::getInt32Ty(ctx),
                /* pixelOffset          */ Type::getInt32Ty(ctx),
                /* depthBiasPreAdjusted */ Type::getInt32Ty(ctx),
                /* conservativeRast     */ Type::getInt32Ty(ctx),
                /* pointSize            */ Type::getFloatTy(ctx),
                /* lineWidth            */ Type::getFloatTy(ctx),
                /* depthBias            */ Type::getFloatTy(ctx),
                /* slopeScaledDepthBias */ Type::getFloatTy(ctx),
                /* depthBiasClamp       */ Type::getFloatTy(ctx),
                /* depthFormat          */ Type::getInt32Ty(ctx),
                /* sampleCount          */ Type::getInt32Ty(ctx),
                /* pixelLocation        */ Type::getInt32Ty(ctx),
                /* samplePositions      */ ArrayType::get(Type::getInt8Ty(ctx), sizeof(SWR_MULTISAMPLE_POS)),
                /* bIsCenterPattern     */ Type::getInt32Ty(ctx),
            };

            pRetType = StructType::create(members, "SWR_RASTSTATE", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("cullMode",             1062),
                std::make_pair("fillMode",             1063),
                std::make_pair("frontWinding",         1064),
                std::make_pair("scissorEnable",        1065),
                std::make_pair("depthClipEnable",      1066),
                std::make_pair("clipEnable",           1067),
                std::make_pair("clipHalfZ",            1068),
                std::make_pair("pointParam",           1069),
                std::make_pair("pointSpriteEnable",    1070),
                std::make_pair("pointSpriteTopOrigin", 1071),
                std::make_pair("forcedSampleCount",    1072),
                std::make_pair("pixelOffset",          1073),
                std::make_pair("depthBiasPreAdjusted", 1074),
                std::make_pair("conservativeRast",     1075),
                std::make_pair("pointSize",            1077),
                std::make_pair("lineWidth",            1078),
                std::make_pair("depthBias",            1080),
                std::make_pair("slopeScaledDepthBias", 1081),
                std::make_pair("depthBiasClamp",       1082),
                std::make_pair("depthFormat",          1083),
                std::make_pair("sampleCount",          1086),
                std::make_pair("pixelLocation",        1087),
                std::make_pair("samplePositions",      1088),
                std::make_pair("bIsCenterPattern",     1089),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_RASTSTATE", pFile, 1060, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_RASTSTATE_cullMode             = 0;
    static const uint32_t SWR_RASTSTATE_fillMode             = 1;
    static const uint32_t SWR_RASTSTATE_frontWinding         = 2;
    static const uint32_t SWR_RASTSTATE_scissorEnable        = 3;
    static const uint32_t SWR_RASTSTATE_depthClipEnable      = 4;
    static const uint32_t SWR_RASTSTATE_clipEnable           = 5;
    static const uint32_t SWR_RASTSTATE_clipHalfZ            = 6;
    static const uint32_t SWR_RASTSTATE_pointParam           = 7;
    static const uint32_t SWR_RASTSTATE_pointSpriteEnable    = 8;
    static const uint32_t SWR_RASTSTATE_pointSpriteTopOrigin = 9;
    static const uint32_t SWR_RASTSTATE_forcedSampleCount    = 10;
    static const uint32_t SWR_RASTSTATE_pixelOffset          = 11;
    static const uint32_t SWR_RASTSTATE_depthBiasPreAdjusted = 12;
    static const uint32_t SWR_RASTSTATE_conservativeRast     = 13;
    static const uint32_t SWR_RASTSTATE_pointSize            = 14;
    static const uint32_t SWR_RASTSTATE_lineWidth            = 15;
    static const uint32_t SWR_RASTSTATE_depthBias            = 16;
    static const uint32_t SWR_RASTSTATE_slopeScaledDepthBias = 17;
    static const uint32_t SWR_RASTSTATE_depthBiasClamp       = 18;
    static const uint32_t SWR_RASTSTATE_depthFormat          = 19;
    static const uint32_t SWR_RASTSTATE_sampleCount          = 20;
    static const uint32_t SWR_RASTSTATE_pixelLocation        = 21;
    static const uint32_t SWR_RASTSTATE_samplePositions      = 22;
    static const uint32_t SWR_RASTSTATE_bIsCenterPattern     = 23;

    INLINE static StructType* Gen_SWR_ATTRIB_SWIZZLE(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_ATTRIB_SWIZZLE");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_ATTRIB_SWIZZLE");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* sourceAttrib          */ Type::getInt16Ty(ctx),
                /* constantSource        */ Type::getInt16Ty(ctx),
                /* componentOverrideMask */ Type::getInt16Ty(ctx),
            };

            pRetType = StructType::create(members, "SWR_ATTRIB_SWIZZLE", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("sourceAttrib",          1103),
                std::make_pair("constantSource",        1104),
                std::make_pair("componentOverrideMask", 1105),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_ATTRIB_SWIZZLE", pFile, 1101, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_ATTRIB_SWIZZLE_sourceAttrib          = 0;
    static const uint32_t SWR_ATTRIB_SWIZZLE_constantSource        = 1;
    static const uint32_t SWR_ATTRIB_SWIZZLE_componentOverrideMask = 2;

    INLINE static StructType* Gen_SWR_BACKEND_STATE(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_BACKEND_STATE");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_BACKEND_STATE");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* constantInterpolationMask  */ Type::getInt32Ty(ctx),
                /* pointSpriteTexCoordMask    */ Type::getInt32Ty(ctx),
                /* swizzleEnable              */ Type::getInt8Ty(ctx),
                /* numAttributes              */ Type::getInt8Ty(ctx),
                /* numComponents              */ ArrayType::get(Type::getInt8Ty(ctx), 32),
                /* readRenderTargetArrayIndex */ Type::getInt8Ty(ctx),
                /* readViewportArrayIndex     */ Type::getInt8Ty(ctx),
                /* cullDistanceMask           */ Type::getInt8Ty(ctx),
                /* clipDistanceMask           */ Type::getInt8Ty(ctx),
                /* pad                        */ ArrayType::get(Type::getInt8Ty(ctx), 10),
                /* vertexAttribOffset         */ Type::getInt32Ty(ctx),
                /* vertexClipCullOffset       */ Type::getInt32Ty(ctx),
                /* swizzleMap                 */ ArrayType::get(Gen_SWR_ATTRIB_SWIZZLE(pJitMgr), 32),
            };

            pRetType = StructType::create(members, "SWR_BACKEND_STATE", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("constantInterpolationMask",  1111),
                std::make_pair("pointSpriteTexCoordMask",    1113),
                std::make_pair("swizzleEnable",              1116),
                std::make_pair("numAttributes",              1119),
                std::make_pair("numComponents",              1120),
                std::make_pair("readRenderTargetArrayIndex", 1123),
                std::make_pair("readViewportArrayIndex",     1125),
                std::make_pair("cullDistanceMask",           1128),
                std::make_pair("clipDistanceMask",           1129),
                std::make_pair("pad",                        1133),
                std::make_pair("vertexAttribOffset",         1136),
                std::make_pair("vertexClipCullOffset",       1139),
                std::make_pair("swizzleMap",                 1141),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_BACKEND_STATE", pFile, 1109, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_BACKEND_STATE_constantInterpolationMask  = 0;
    static const uint32_t SWR_BACKEND_STATE_pointSpriteTexCoordMask    = 1;
    static const uint32_t SWR_BACKEND_STATE_swizzleEnable              = 2;
    static const uint32_t SWR_BACKEND_STATE_numAttributes              = 3;
    static const uint32_t SWR_BACKEND_STATE_numComponents              = 4;
    static const uint32_t SWR_BACKEND_STATE_readRenderTargetArrayIndex = 5;
    static const uint32_t SWR_BACKEND_STATE_readViewportArrayIndex     = 6;
    static const uint32_t SWR_BACKEND_STATE_cullDistanceMask           = 7;
    static const uint32_t SWR_BACKEND_STATE_clipDistanceMask           = 8;
    static const uint32_t SWR_BACKEND_STATE_pad                        = 9;
    static const uint32_t SWR_BACKEND_STATE_vertexAttribOffset         = 10;
    static const uint32_t SWR_BACKEND_STATE_vertexClipCullOffset       = 11;
    static const uint32_t SWR_BACKEND_STATE_swizzleMap                 = 12;

    INLINE static StructType* Gen_SWR_PS_STATE(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_PS_STATE");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_PS_STATE");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* pfnPixelShader   */ PointerType::get(Type::getInt8Ty(ctx), 0),
                /* killsPixel       */ Type::getInt32Ty(ctx),
                /* inputCoverage    */ Type::getInt32Ty(ctx),
                /* writesODepth     */ Type::getInt32Ty(ctx),
                /* usesSourceDepth  */ Type::getInt32Ty(ctx),
                /* shadingRate      */ Type::getInt32Ty(ctx),
                /* posOffset        */ Type::getInt32Ty(ctx),
                /* barycentricsMask */ Type::getInt32Ty(ctx),
                /* usesUAV          */ Type::getInt32Ty(ctx),
                /* forceEarlyZ      */ Type::getInt32Ty(ctx),
                /* renderTargetMask */ Type::getInt8Ty(ctx),
            };

            pRetType = StructType::create(members, "SWR_PS_STATE", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("pfnPixelShader",   1216),
                std::make_pair("killsPixel",       1219),
                std::make_pair("inputCoverage",    1220),
                std::make_pair("writesODepth",     1221),
                std::make_pair("usesSourceDepth",  1222),
                std::make_pair("shadingRate",      1223),
                std::make_pair("posOffset",        1224),
                std::make_pair("barycentricsMask", 1225),
                std::make_pair("usesUAV",          1227),
                std::make_pair("forceEarlyZ",      1228),
                std::make_pair("renderTargetMask", 1230),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_PS_STATE", pFile, 1213, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_PS_STATE_pfnPixelShader   = 0;
    static const uint32_t SWR_PS_STATE_killsPixel       = 1;
    static const uint32_t SWR_PS_STATE_inputCoverage    = 2;
    static const uint32_t SWR_PS_STATE_writesODepth     = 3;
    static const uint32_t SWR_PS_STATE_usesSourceDepth  = 4;
    static const uint32_t SWR_PS_STATE_shadingRate      = 5;
    static const uint32_t SWR_PS_STATE_posOffset        = 6;
    static const uint32_t SWR_PS_STATE_barycentricsMask = 7;
    static const uint32_t SWR_PS_STATE_usesUAV          = 8;
    static const uint32_t SWR_PS_STATE_forceEarlyZ      = 9;
    static const uint32_t SWR_PS_STATE_renderTargetMask = 10;

    INLINE static StructType* Gen_SWR_DEPTH_BOUNDS_STATE(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_DEPTH_BOUNDS_STATE");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_DEPTH_BOUNDS_STATE");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* depthBoundsTestEnable   */ Type::getInt8Ty(ctx),
                /* depthBoundsTestMinValue */ Type::getFloatTy(ctx),
                /* depthBoundsTestMaxValue */ Type::getFloatTy(ctx),
            };

            pRetType = StructType::create(members, "SWR_DEPTH_BOUNDS_STATE", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("state.h", "../src/gallium/drivers/swr/rasterizer/core");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("depthBoundsTestEnable",   1236),
                std::make_pair("depthBoundsTestMinValue", 1237),
                std::make_pair("depthBoundsTestMaxValue", 1238),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_DEPTH_BOUNDS_STATE", pFile, 1234, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_DEPTH_BOUNDS_STATE_depthBoundsTestEnable   = 0;
    static const uint32_t SWR_DEPTH_BOUNDS_STATE_depthBoundsTestMinValue = 1;
    static const uint32_t SWR_DEPTH_BOUNDS_STATE_depthBoundsTestMaxValue = 2;

} // namespace SwrJit


// clang-format on
