/****************************************************************************
 * Copyright (C) 2014-2018 Intel Corporation.   All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 *
 * @file gen_surf_state_llvm.h
 *
 * @brief auto-generated file
 *
 * DO NOT EDIT
 *
 * Generation Command Line:
 *   ../src/gallium/drivers/swr/rasterizer/codegen/gen_llvm_types.py
 *     --input
 *     ../src/gallium/drivers/swr/rasterizer/memory/SurfaceState.h
 *     --output
 *     src/gallium/drivers/swr/rasterizer/codegen/gen_surf_state_llvm.h
 *
 ******************************************************************************/
// clang-format off

#include <llvm/IR/DerivedTypes.h>

#pragma once

namespace SwrJit
{
    using namespace llvm;

    INLINE static StructType* Gen_SWR_SURFACE_STATE(JitManager* pJitMgr)
    {
        LLVMContext& ctx = pJitMgr->mContext;

#if LLVM_VERSION_MAJOR >= 12
        StructType* pRetType = StructType::getTypeByName(pJitMgr->mContext, "SWR_SURFACE_STATE");
#else
        StructType* pRetType = pJitMgr->mpCurrentModule->getTypeByName("SWR_SURFACE_STATE");
#endif
        if (pRetType == nullptr)
        {
            std::vector<Type*> members =
            {
                /* xpBaseAddress       */ Type::getInt64Ty(ctx),
                /* type                */ Type::getInt32Ty(ctx),
                /* format              */ Type::getInt32Ty(ctx),
                /* width               */ Type::getInt32Ty(ctx),
                /* height              */ Type::getInt32Ty(ctx),
                /* depth               */ Type::getInt32Ty(ctx),
                /* numSamples          */ Type::getInt32Ty(ctx),
                /* samplePattern       */ Type::getInt32Ty(ctx),
                /* pitch               */ Type::getInt32Ty(ctx),
                /* qpitch              */ Type::getInt32Ty(ctx),
                /* minLod              */ Type::getInt32Ty(ctx),
                /* maxLod              */ Type::getInt32Ty(ctx),
                /* resourceMinLod      */ Type::getFloatTy(ctx),
                /* lod                 */ Type::getInt32Ty(ctx),
                /* arrayIndex          */ Type::getInt32Ty(ctx),
                /* tileMode            */ Type::getInt32Ty(ctx),
                /* halign              */ Type::getInt32Ty(ctx),
                /* valign              */ Type::getInt32Ty(ctx),
                /* xOffset             */ Type::getInt32Ty(ctx),
                /* yOffset             */ Type::getInt32Ty(ctx),
                /* lodOffsets          */ ArrayType::get(ArrayType::get(Type::getInt32Ty(ctx), 15), 2),
                /* xpAuxBaseAddress    */ Type::getInt64Ty(ctx),
                /* auxMode             */ Type::getInt32Ty(ctx),
                /* bInterleavedSamples */ Type::getInt8Ty(ctx),
            };

            pRetType = StructType::create(members, "SWR_SURFACE_STATE", false);

            // Compute debug metadata
            llvm::DIBuilder builder(*pJitMgr->mpCurrentModule);
            llvm::DIFile* pFile = builder.createFile("SurfaceState.h", "../src/gallium/drivers/swr/rasterizer/memory");

            std::vector<std::pair<std::string, uint32_t>> dbgMembers =
            {
                std::make_pair("xpBaseAddress",       37),
                std::make_pair("type",                38),
                std::make_pair("format",              39),
                std::make_pair("width",               40),
                std::make_pair("height",              41),
                std::make_pair("depth",               42),
                std::make_pair("numSamples",          43),
                std::make_pair("samplePattern",       44),
                std::make_pair("pitch",               45),
                std::make_pair("qpitch",              46),
                std::make_pair("minLod",              47),
                std::make_pair("maxLod",              48),
                std::make_pair("resourceMinLod",      49),
                std::make_pair("lod",                 51),
                std::make_pair("arrayIndex",          52),
                std::make_pair("tileMode",            53),
                std::make_pair("halign",              54),
                std::make_pair("valign",              55),
                std::make_pair("xOffset",             56),
                std::make_pair("yOffset",             57),
                std::make_pair("lodOffsets",          59),
                std::make_pair("xpAuxBaseAddress",    61),
                std::make_pair("auxMode",             62),
                std::make_pair("bInterleavedSamples", 65),
            };
            pJitMgr->CreateDebugStructType(pRetType, "SWR_SURFACE_STATE", pFile, 35, dbgMembers);
        }

        return pRetType;
    }

    static const uint32_t SWR_SURFACE_STATE_xpBaseAddress       = 0;
    static const uint32_t SWR_SURFACE_STATE_type                = 1;
    static const uint32_t SWR_SURFACE_STATE_format              = 2;
    static const uint32_t SWR_SURFACE_STATE_width               = 3;
    static const uint32_t SWR_SURFACE_STATE_height              = 4;
    static const uint32_t SWR_SURFACE_STATE_depth               = 5;
    static const uint32_t SWR_SURFACE_STATE_numSamples          = 6;
    static const uint32_t SWR_SURFACE_STATE_samplePattern       = 7;
    static const uint32_t SWR_SURFACE_STATE_pitch               = 8;
    static const uint32_t SWR_SURFACE_STATE_qpitch              = 9;
    static const uint32_t SWR_SURFACE_STATE_minLod              = 10;
    static const uint32_t SWR_SURFACE_STATE_maxLod              = 11;
    static const uint32_t SWR_SURFACE_STATE_resourceMinLod      = 12;
    static const uint32_t SWR_SURFACE_STATE_lod                 = 13;
    static const uint32_t SWR_SURFACE_STATE_arrayIndex          = 14;
    static const uint32_t SWR_SURFACE_STATE_tileMode            = 15;
    static const uint32_t SWR_SURFACE_STATE_halign              = 16;
    static const uint32_t SWR_SURFACE_STATE_valign              = 17;
    static const uint32_t SWR_SURFACE_STATE_xOffset             = 18;
    static const uint32_t SWR_SURFACE_STATE_yOffset             = 19;
    static const uint32_t SWR_SURFACE_STATE_lodOffsets          = 20;
    static const uint32_t SWR_SURFACE_STATE_xpAuxBaseAddress    = 21;
    static const uint32_t SWR_SURFACE_STATE_auxMode             = 22;
    static const uint32_t SWR_SURFACE_STATE_bInterleavedSamples = 23;

} // namespace SwrJit


// clang-format on
