#ifndef ZINK_INSTANCE_H
#define ZINK_INSTANCE_H

#include "os/os_process.h"

#include <vulkan/vulkan.h>

#if defined(__APPLE__)
// Source of MVK_VERSION
// Source of VK_EXTX_PORTABILITY_SUBSET_EXTENSION_NAME
#include "MoltenVK/vk_mvk_moltenvk.h"
#endif

struct zink_screen;

struct zink_instance_info {
   uint32_t loader_version;

   bool have_EXT_debug_utils;
   bool have_KHR_get_physical_device_properties2;
   bool have_MVK_moltenvk;

   bool have_layer_KHRONOS_validation;
   bool have_layer_LUNARG_standard_validation;
};

VkInstance
zink_create_instance(struct zink_instance_info *instance_info);

bool
zink_load_instance_extensions(struct zink_screen *screen);

#endif
